bpalavars = {};

bitPala = {
	beacon = {
		target = "";
		status = 0;
		timeleft = 0;
		max = 300;
	};
	
	judge = {
		target = "";
		status = 0;
		timeleft = 0;
		max = 60;
	};
	
	power = {
		status = 0;
		amount = 0;
		timeleft = 0;
		max = 3;
	};
	
	colors = {
		background = { r = 1.0;  g = 0.0;  b = 0.0; alpha = 1; };
		ready      = { r = 0.2;  g = 0.2;  b = 0.2; };
		active     = { r = 0.2;  g = 0.2;  b = 0.2; };
		faded      = { r = 1.0;  g = 1.0;  b = 1.0; };
	};
	
	spell = {
		event  = "";
		caster = "";
		target = "";
		id     = "";
		name   = "";
	};
	
	bars = {"power", "beacon", "judge"};
	seconds = 0;
	
	onLoad = function()
		bitPala_core:RegisterEvent("VARIABLES_LOADED");
		bitPala_core:RegisterEvent("RAID_ROSTER_UPDATE");
		bitPala_core:RegisterEvent("PARTY_MEMBERS_CHANGED");
		bitPala_core:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
		bitPala_core:RegisterEvent("UNIT_POWER");
		SlashCmdList["bitPala"] = function(cmd)
			local args = "";
			cmd = strtrim(strlower(cmd));
			if (strfind(cmd, " ") ~= nil) then
				args = strsub(cmd, strfind(cmd, " ") + 1);
				cmd = strsub(cmd, 0, strfind(cmd, " ") - 1);
			end
			if (cmd == "") then
				DEFAULT_CHAT_FRAME:AddMessage("-- bitPala --");
				DEFAULT_CHAT_FRAME:AddMessage("/bp on (off)");
				DEFAULT_CHAT_FRAME:AddMessage("/bp lock (unlock)");
				DEFAULT_CHAT_FRAME:AddMessage("/bp scale (default scale: 1)");
				DEFAULT_CHAT_FRAME:AddMessage("/bp style");
			elseif (cmd == "enable" or cmd == "on") then
				bpalavars.enabled = 1;
				bitPala_core:Show();
				DEFAULT_CHAT_FRAME:AddMessage("[bitPala] Enabled");
			elseif (cmd == "disable" or cmd == "off") then
				bpalavars.enabled = 2;
				bitPala_core:Hide();
				DEFAULT_CHAT_FRAME:AddMessage("[bitPala] Disabled");
			elseif (cmd == "scale" or cmd == "size") then
				if (args ~= "") then
					bitPala_core:SetScale(args);
					bpalavars.scale = args;
				end
				DEFAULT_CHAT_FRAME:AddMessage("[bitPala] Scale: "..bpalavars.scale);
			elseif (cmd == "lock") then
				bpalavars.locked = 1;
				bitPala_moveOverlay:Hide();
				DEFAULT_CHAT_FRAME:AddMessage("[bitPala] Frame locked");
			elseif (cmd == "unlock" or cmd == "move") then
				bpalavars.locked = 0;
				bitPala_moveOverlay:Show();
				DEFAULT_CHAT_FRAME:AddMessage("[bitPala] Frame unlocked");
			elseif (cmd == "style") then
				if (args == "1") then
					bpalavars.style = 1;
				elseif (args == "2") then
					bpalavars.style = 2;
				elseif (bpalavars.style == 1) then
					bpalavars.style = 2;
				else
					bpalavars.style = 1;
				end
				bitPala.setStyle(bpalavars.style);
				DEFAULT_CHAT_FRAME:AddMessage("[bitPala] Style changed to '"..bpalavars.style.."'");
			elseif (cmd == "lulz") then
				local outp = "active";
				if (args == "1") then
					bpalavars.lulz = 1;
				elseif (args == "0") then
					bpalavars.lulz = 0;
					outp = "deavtivated";
				elseif (bpalavars.lulz == 1) then
					bpalavars.lulz = 0;
					outp = "deavtivated";
				else
					bpalavars.lulz = 1;
				end
				DEFAULT_CHAT_FRAME:AddMessage("[bitPala] Lulz changed to '"..bpalavars.lulz.."'");
			else
				DEFAULT_CHAT_FRAME:AddMessage("[bitPala] Command not found: "..tostring(cmd));
			end
		end
		SLASH_bitPala1 = "/bitPala";
		SLASH_bitPala2 = "/bp";
	end;

	onEvent = function(self, event, ...)
		local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10 = ...;
		if (event == "VARIABLES_LOADED") then
			if (bpalavars.enabled == nil) then
				bpalavars.enabled = 1;
				bpalavars.scale = 1;
				bpalavars.locked = 0;
			end
			if (bpalavars.style == nil) then
				bpalavars.style = 1;
			end
			if (bpalavars.lulz == nil) then
				bpalavars.lulz = 0;
			end
			bitPala.setStyle(bpalavars.style);
			if (bpalavars.locked == 1) then
				bitPala_moveOverlay:Hide();
			end
			--if (GetNumPartyMembers() > 0 or GetNumRaidMembers() > 0) then
				if (bpalavars.enabled == 1) then
					bitPala_core:Show();
				end
			--end
			bitPala_moveOverlay:RegisterForDrag("LeftButton");
			bitPala_core:SetScale(bpalavars.scale);
			bitPala_moveOverlay:SetBackdropBorderColor(0, 0, 0, 1);
			bitPala_moveOverlay:SetBackdropColor(0, 0, 0, 0.5);
			bitPala_title:SetText("bitPala");
			bitPala.initBar("power", "ABILITY_PALADIN_BLESSEDMENDING");
			bitPala.updateBarStatus("power");
			bitPala.initBar("beacon", "ABILITY_PALADIN_BEACONOFLIGHT");
			bitPala.updateBarStatus("beacon");
			bitPala.initBar("judge", "ABILITY_PALADIN_JUDGEMENTOFTHEPURE");
			bitPala.updateBarStatus("judge");
		elseif (event == "PARTY_MEMBERS_CHANGED") then
			if (GetNumPartyMembers() == 0 and GetNumRaidMembers() == 0) then
				--bitPala_core:Hide();
			elseif (bpalavars.enabled == 1) then
				--bitPala_core:Show();
			end
		elseif (event == "RAID_ROSTER_UPDATE") then
			if (GetNumRaidMembers() == 0) then
				-- bitPala_shockwave:Show();
			else
				-- bitPala_shockwave:Hide();
			end
		elseif (event == "UNIT_POWER") then
			if (tostring(arg1) == "player" and tostring(arg2) == "HOLY_POWER") then
				bitPala.power.amount = bitPala.holyPower();
				if (bitPala.power.amount == 0) then
					bitPala.power.status = 2;
				else
					bitPala.power.status = 1;
					bitPala.power.timeleft = 1;
				end
				bitPala.updateBarStatus("power");
			end
		elseif (event == "COMBAT_LOG_EVENT_UNFILTERED") then
			bitPala.spell.event  = tostring(arg2);
			bitPala.spell.caster = tostring(arg4);
			bitPala.spell.target = tostring(arg7);
			bitPala.spell.id     = tostring(arg9);
			bitPala.spell.name   = tostring(arg10);
			if (bitPala.spell.caster == UnitName("player")) then
				if (bitPala.spell.event == "SPELL_CAST_SUCCESS") then
					if (bitPala.spell.id == "53563") then
						bitPala.beacon.status = 1;
						bitPala.beacon.target = bitPala.spell.target;
						bitPala.beacon.timeleft = bitPala.beacon.max;
						bitPala.updateBarStatus("beacon");
					elseif (bitPala.spell.id == "642") then
						if (bpalavars.lulz == 1) then
							ChatFrame1:AddMessage("Bubble detected on "..bitPala.spell.caster);
							PlaySoundFile("Interface\\AddOns\\bitPala\\imba.mp3");
						end
					end
				elseif (bitPala.spell.event == "SPELL_AURA_APPLIED" or bitPala.spell.event == "SPELL_AURA_REFRESH") then
					if (bitPala.spell.id == "53657") then --old id: 54153
						bitPala.judge.status = 1;
						bitPala.judge.timeleft = bitPala.judge.max;
						bitPala.updateBarStatus("judge");
					end
				elseif (bitPala.spell.event == "SPELL_AURA_REMOVED") then
					if (bitPala.spell.id == "53563") then
						if (bitPala.spell.target == bitPala.beacon.target) then
							if (bitPala.buffFaded(bitPala.beacon.target, "Beacon of Light") == 1) then
								bitPala.beacon.status = 2;
								bitPala.updateBarStatus("beacon");
							end
						end
					elseif (bitPala.spell.id == "54153") then
						--if (spell.target == bitPala.shield.target) then
							--bitPala.judge.status = 2;
							--bitPala.updateBarStatus("judge");
						--end
					end
				end
			end
		end
	end;
	
	holyPower = function()
		local powr = UnitPower("player", 9);
		if (powr == nil) then
			powr = 0;
		end
		return(tonumber(powr));
	end;
	
	buffFaded = function(unitName, buffName)
		local i = 1;
		local buff,_,_,_,_,_,_,isMine = UnitBuff(unitName, i);
		while buff do
			if (buff == buffName) then
				if (isMine == "player") then
					return(0);
				end
			end
		  i = i + 1;
		  buff,_,_,_,_,_,_,isMine = UnitBuff(unitName, i);
		end
		return(1);
	end;
	
	
	setStyle = function(newStyle)
		if (newStyle == 1) then
			bitPala_beacon_rightText:SetFont("Fonts\\FRIZQT__.TTF",10,"OUTLINE")
			bitPala_beacon_bar:Show();
			bitPala_beacon:SetWidth(220);
			bitPala_beacon_leftText:Show();
			bitPala_beacon_rightText:ClearAllPoints();
			bitPala_beacon_rightText:SetPoint("RIGHT",bitPala_beacon,"RIGHT", -6, 0);
			bitPala_judge_rightText:SetFont("Fonts\\FRIZQT__.TTF",10,"OUTLINE")
			bitPala_judge_bar:Show();
			bitPala_judge:SetWidth(220);
			bitPala_judge_leftText:Show();
			bitPala_judge_rightText:ClearAllPoints();
			bitPala_judge_rightText:SetPoint("RIGHT",bitPala_judge,"RIGHT", -6, 0);
			bitPala_power_rightText:SetFont("Fonts\\FRIZQT__.TTF",10,"OUTLINE")
			bitPala_power_bar:Show();
			bitPala_power:SetWidth(220);
			bitPala_power_leftText:Show();
			bitPala_power_rightText:ClearAllPoints();
			bitPala_power_rightText:SetPoint("RIGHT",bitPala_power,"RIGHT", -6, 0);
		else
			bitPala_beacon_rightText:SetFont("Fonts\\FRIZQT__.TTF",8,"OUTLINE");
			bitPala_beacon_bar:Hide();
			bitPala_beacon:SetWidth(20);
			bitPala_beacon_leftText:Hide();
			bitPala_beacon_rightText:ClearAllPoints();
			bitPala_beacon_rightText:SetPoint("TOP",bitPala_beacon_icon,"TOP");
			bitPala_judge_rightText:SetFont("Fonts\\FRIZQT__.TTF",8,"OUTLINE");
			bitPala_judge_bar:Hide();
			bitPala_judge:SetWidth(20);
			bitPala_judge_leftText:Hide();
			bitPala_judge_rightText:ClearAllPoints();
			bitPala_judge_rightText:SetPoint("TOP",bitPala_judge_icon,"TOP");
			bitPala_power_rightText:SetFont("Fonts\\FRIZQT__.TTF",8,"OUTLINE");
			bitPala_power_bar:Hide();
			bitPala_power:SetWidth(20);
			bitPala_power_leftText:Hide();
			bitPala_power_rightText:ClearAllPoints();
			bitPala_power_rightText:SetPoint("TOP",bitPala_power_icon,"TOP");
		end
	end;
	
	
	initBar = function(barname, icon)
		_G["bitPala_"..barname.."_icon"]:SetTexture("Interface\\Icons\\"..icon);
		_G["bitPala_"..barname.."_icon"]:SetTexCoord(0.1, 0.9, 0.1, 0.9);
		_G["bitPala_"..barname]:SetBackdropBorderColor(0, 0, 0, 1);
		_G["bitPala_"..barname.."_bar"]:SetVertexColor(bitPala.colors.ready.r, bitPala.colors.ready.g, bitPala.colors.ready.b);
		_G["bitPala_"..barname]:SetBackdropColor(bitPala.colors.background.r, bitPala.colors.background.g, bitPala.colors.background.b, bitPala.colors.background.alpha);
		_G["bitPala_"..barname.."_leftText"]:SetText("");
		_G["bitPala_"..barname.."_midText"]:SetText("");
		_G["bitPala_"..barname.."_rightText"]:SetText("");
	end;
	
	
	updateBarStatus = function(barname)
		_G["bitPala_"..barname.."_leftText"]:SetText(bitPala[barname].target);
		if (bitPala[barname].status == 0) then
			_G["bitPala_"..barname]:Hide();
		elseif (bitPala[barname].status == 1) then
			_G["bitPala_"..barname]:Show();
			_G["bitPala_"..barname]:SetAlpha(1);
			_G["bitPala_"..barname.."_bar"]:SetVertexColor(bitPala.colors.active.r, bitPala.colors.active.g, bitPala.colors.active.b);
		elseif (bitPala[barname].status == 2) then
			_G["bitPala_"..barname]:Show();
			_G["bitPala_"..barname]:SetAlpha(1);
			bitPala[barname].timeleft = 1;
			bitPala.setBar(barname, 1);
			_G["bitPala_"..barname.."_rightText"]:SetText("");
		elseif (bitPala[barname].status == 3) then
			_G["bitPala_"..barname]:Show();
			bitPala[barname].timeleft = 1;
			bitPala.setBar(barname, 1);
			_G["bitPala_"..barname.."_rightText"]:SetText("");
		end
	end;

	cleanTimeLeft = function(barname)
		bitPala.seconds = floor(bitPala[barname].timeleft);
		if (bitPala.seconds > 60) then
			return(floor(bitPala.seconds/60)..":"..(bitPala.seconds%60));
		else
			return(bitPala.seconds);
		end
	end;

	onUpdate = function(elapsed)
		for _, barname in pairs(bitPala.bars) do
			if (bitPala[barname].status > 0) then
				if (barname ~= "power" or bitPala[barname].status ~= 1) then
					bitPala[barname].timeleft = bitPala[barname].timeleft - elapsed;
				end
				if (bitPala[barname].timeleft > 0) then
					if (bitPala[barname].status == 1) then
						if (barname == "power") then
							bitPala.setBar(barname, (bitPala.power.amount / bitPala.power.max));
							_G["bitPala_power_rightText"]:SetText(bitPala.power.amount);
						else
							bitPala.setBar(barname, (bitPala[barname].timeleft/bitPala[barname].max));
							_G["bitPala_"..barname.."_rightText"]:SetText(bitPala.cleanTimeLeft(barname));
						end
					elseif (bitPala[barname].status == 2) then
						local color = {
							r = bitPala[barname].timeleft * bitPala.colors.faded.r;
							g = bitPala[barname].timeleft * bitPala.colors.faded.g;
							b = bitPala[barname].timeleft * bitPala.colors.faded.b;
						}
						_G["bitPala_"..barname.."_bar"]:SetVertexColor(color.r, color.g, color.b);
					elseif (bitPala[barname].status == 3) then
						local color = {
							r = .5 * (1 - bitPala[barname].timeleft) * bitPala.colors.background.r;
							g = .5 * (1 - bitPala[barname].timeleft) * bitPala.colors.background.g;
							b = .5 * (1 - bitPala[barname].timeleft) * bitPala.colors.background.b;
						}
						_G["bitPala_"..barname.."_bar"]:SetVertexColor(color.r, color.g, color.b);
						_G["bitPala_"..barname]:SetAlpha(bitPala[barname].timeleft);
					end
				else
					bitPala[barname].status = bitPala[barname].status + 1;
					if (bitPala[barname].status > 3) then
						bitPala[barname].status = 0;
					end
					bitPala.updateBarStatus(barname);
				end
			end
		end
	end;

	setBar = function(barname, value)
		local barWidth = 200;
		if (value <= 0) then
			value = 0.00001;
		elseif (value > 1) then
			value = 1;
		end
		_G["bitPala_"..barname.."_bar"]:SetTexCoord(0, value, 0, 1);
		_G["bitPala_"..barname.."_bar"]:SetWidth(value * barWidth);
	end;
}